var objLinkify =
{
	prefService : Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('linkification.settings.'),

	sDefaultTextColor : "#006620",
	sDefaultBackgroundColor : "#fff9ab",
	sDefaultProtocol : "h..p:http,h...s:https,f.p:ftp,news:news,nntp:nntp,telnet:telnet,irc:irc,mms:mms,ed2k:ed2k,file:file,about:about!,mailto:mailto!",
	sDefaultSubdomain : "www:http,ftp:ftp,irc:irc",
	sDefaultSiteList : "localhost,google.com",
	sDefaultInlineElements : "a,abbr,acronym,b,basefont,bdo,big,cite,code,dfn,em,font,i,kbd,label,nobr,q,s,samp,small,span,strike,strong,sub,sup,tt,u,wbr,var",
	sDefaultExcludeElements : "a,applet,area,embed,frame,frameset,head,iframe,map,meta,noscript,object,option,param,script,select,style,textarea,title,*[@onclick],*[@onmousedown],*[@onmouseup],*[@tiddler],*[@class='linkification-disabled']",

	sSelectedLink : "",

	nLinkified : 0,

	// Thanks: SHIMODA Hiroshi
	aTopLevelDomains : [
		// iTLD , gTLD
		'arpa', 'int', 'nato', 'com', 'net', 'org', 'info', 'biz', 'name', 'pro', 'museum', 'coop', 'aero', 'edu', 'gov', 'mil',

		// ccTLD
		'ac', 'ad', 'ae', 'af', 'ag', 'ai', 'al', 'am', 'an', 'ao', 'aq', 'ar', 'as', 'at', 'au', 'aw', 'ax', 'az',
		'ba', 'bb', 'bd', 'be', 'bf', 'bg', 'bh', 'bi', 'bj', 'bm', 'bn', 'bo', 'br', 'bs', 'bt', 'bu', 'bv', 'bw', 'by', 'bz',
		'ca', 'cc', 'cd', 'cf', 'cg', 'ch', 'ci', 'ck', 'cl', 'cm', 'cn', 'co', 'cp', 'cr', 'cs', 'sk', 'cu', 'cv', 'cx', 'cy', 'cz',
		'dd', 'de', 'dg', 'dj', 'dk', 'dm', 'do', 'dz',
		'ea', 'ec', 'ee', 'eg', 'eh', 'er', 'es', 'et',
		'fi', 'fj', 'fk', 'fm', 'fo', 'fr', 'fx',
		'ga', 'gb', 'gd', 'ge', 'gf', 'gg', 'gh', 'gi', 'gl', 'gm', 'gn', 'gp', 'gq', 'gr', 'gs', 'gt', 'gu', 'gw', 'gy',
		'hk', 'hm', 'hn', 'hr', 'ht', 'hu',
		'ic', 'id', 'ie', 'il', 'im', 'in', 'io', 'iq', 'ir', 'is', 'it',
		'je', 'jm', 'jo', 'jp',
		'ke', 'kg', 'kh', 'ki', 'km', 'kn', 'kp', 'kr', 'kw', 'ky', 'kz',
		'la', 'lb', 'lc', 'li', 'lk', 'lr', 'ls', 'lt', 'lu', 'lv', 'ly',
		'ma', 'mc', 'md', 'mg', 'mh', 'mk', 'ml', 'mm', 'mn', 'mo', 'mp', 'mq', 'mr', 'ms', 'mt', 'mu', 'mv', 'mw', 'mx', 'my', 'mz',
		'na', 'nc', 'ne', 'nf', 'ng', 'ni', 'nl', 'no', 'np', 'nr', 'nt', 'nu', 'nz',
		'om',
		'pa', 'pc', 'pe', 'pf', 'pg', 'ph', 'pk', 'pl', 'pm', 'pn', 'pr', 'ps', 'pt', 'pw', 'py', 'qa',
		're', 'ro', 'ru', 'rw',
		'sa', 'sb', 'sc', 'sd', 'se', 'sg', 'sh', 'si', 'sj', 'sk', 'sl', 'sm', 'sn', 'so', 'sr', 'st', 'su', 'sv', 'sy', 'sz',
		'ta', 'tc', 'td', 'tf', 'tg', 'th', 'tj', 'tk', 'tm', 'tn', 'to', 'tp', 'tr', 'tt', 'tv', 'tw', 'tz',
		'ua', 'ug', 'uk', 'um', 'us', 'uy', 'uz',
		'va', 'vc', 've', 'vg', 'vi', 'vn', 'vu',
		'wf', 'wg', 'ws',
		'yd', 'ye', 'yt', 'yu',
		'za', 'zm', 'zr', 'zw'
	],

	GetPreferences: function()
	{
		this.bThorough = this.prefService.prefHasUserValue('Linkify_Thorough') ? this.prefService.getBoolPref('Linkify_Thorough') : false;
		this.bAutoLinkify = this.prefService.prefHasUserValue('Linkify_Toggle') ? this.prefService.getBoolPref('Linkify_Toggle') : true;
		this.bDoubleClick = this.prefService.prefHasUserValue('Linkify_DoubleClick') ? this.prefService.getBoolPref('Linkify_DoubleClick') : true;
		this.bOpenSelected = this.prefService.prefHasUserValue('Linkify_OpenSelected_Toggle') ? this.prefService.getBoolPref('Linkify_OpenSelected_Toggle') : true;
		this.bContextMenu = this.prefService.prefHasUserValue('Linkify_Popup_Toggle') ? this.prefService.getBoolPref('Linkify_Popup_Toggle') : false;
		this.bStatusBar = this.prefService.prefHasUserValue('Linkify_StatusBar_Toggle') ? this.prefService.getBoolPref('Linkify_StatusBar_Toggle') : true;
		this.bTextColor = this.prefService.prefHasUserValue('Linkify_HighlightText') ? this.prefService.getBoolPref('Linkify_HighlightText') : false;
		this.bBackgroundColor = this.prefService.prefHasUserValue('Linkify_HighlightBG') ? this.prefService.getBoolPref('Linkify_HighlightBG') : false;
		this.sTextColor = this.prefService.prefHasUserValue('Linkify_TextColor') ? this.prefService.getCharPref('Linkify_TextColor') : this.sDefaultTextColor;
		this.sBackgroundColor = this.prefService.prefHasUserValue('Linkify_BackgroundColor') ? this.prefService.getCharPref('Linkify_BackgroundColor') : this.sDefaultBackgroundColor;
		this.bLinksOpenWindows = this.prefService.prefHasUserValue('Linkify_OpenInWindow') ? this.prefService.getBoolPref('Linkify_OpenInWindow') : false;
		this.bLinksOpenTabs = this.prefService.prefHasUserValue('Linkify_OpenInTab') ? this.prefService.getBoolPref('Linkify_OpenInTab') : false;
		this.bTabsOpenInBG = this.prefService.prefHasUserValue('Linkify_OpenTabInBG') ? this.prefService.getBoolPref('Linkify_OpenTabInBG') : false;
		this.bLinkifyImageURLs = this.prefService.prefHasUserValue('Linkify_LinkifyImages') ? this.prefService.getBoolPref('Linkify_LinkifyImages') : true;
		this.bLinkifyProtocol = this.prefService.prefHasUserValue('Linkify_LinkifyProtocol') ? this.prefService.getBoolPref('Linkify_LinkifyProtocol') : true;
		this.bLinkifyKnown = this.prefService.prefHasUserValue('Linkify_LinkifyKnown') ? this.prefService.getBoolPref('Linkify_LinkifyKnown') : true;
		this.bLinkifyUnknown = this.prefService.prefHasUserValue('Linkify_LinkifyUnknown') ? this.prefService.getBoolPref('Linkify_LinkifyUnknown') : true;
		this.bLinkifyEmail = this.prefService.prefHasUserValue('Linkify_LinkifyEmail') ? this.prefService.getBoolPref('Linkify_LinkifyEmail') : true;
		this.sProtocols = this.prefService.prefHasUserValue('Linkify_TextProtocolList') ? this.prefService.getCharPref('Linkify_TextProtocolList') : this.sDefaultProtocol;
		this.sSubDomains = this.prefService.prefHasUserValue('Linkify_SubdomainProtocolList') ? this.prefService.getCharPref('Linkify_SubdomainProtocolList') : this.sDefaultSubdomain;
		this.sInlineElements = this.prefService.prefHasUserValue('Linkify_InlineElements') ? this.prefService.getCharPref('Linkify_InlineElements') : this.sDefaultInlineElements;
		this.sExcludeElements = this.prefService.prefHasUserValue('Linkify_ExcludeElements') ? this.prefService.getCharPref('Linkify_ExcludeElements') : this.sDefaultExcludeElements;
		this.bUseBlacklist = this.prefService.prefHasUserValue('Linkify_Blacklist') ? this.prefService.getBoolPref('Linkify_Blacklist') : true;
		this.bUseWhitelist = this.prefService.prefHasUserValue('Linkify_Whitelist') ? this.prefService.getBoolPref('Linkify_Whitelist') : false;
		this.sSitelist = this.prefService.prefHasUserValue('Linkify_SiteList') ? this.prefService.getCharPref('Linkify_SiteList') : this.sDefaultSiteList;
		this.bEnableCharLimit = this.prefService.prefHasUserValue('Linkify_CharLimitEnabled') ? this.prefService.getBoolPref('Linkify_CharLimitEnabled') : false;
		this.nCharLimit = this.prefService.prefHasUserValue('Linkify_CharLimit') ? this.prefService.getIntPref('Linkify_CharLimit') : 15000;

		return true;
	},

	InitServices: function()
	{
		this.objStringBundle = document.getElementById("linkification-string-bundle");

 		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", this.PopupShowing, false);

		this.Init();

		window.addEventListener("click", this.WindowClick, true);
		window.addEventListener("dblclick", this.WindowDoubleClick, false);
		window.addEventListener('load', this.AutoLinkify, true);
		window.addEventListener('focus', this.WindowFocus, true);

		return true;
	},

	Init: function()
	{
		this.GetPreferences();

		if (this.bStatusBar)
		{
			document.getElementById("linkification-status").setAttribute("collapsed", "false");
		}
		else
		{
			document.getElementById("linkification-status").setAttribute("collapsed", "true");
		}

		this.aExcludeElements = this.sExcludeElements.split(",");
		this.aInlineElements = this.sInlineElements.split(",");
		this.aInlineHash = Array();
		for (ctr = 0; ctr < this.aInlineElements.length; ++ctr)
		{
			this.aInlineHash[this.aInlineElements[ctr]] = true;
		}

		this.aProtocol = Array();
		this.aRecognizeProtocolAs = Array();

		var aTextLinkProtocol;
		var aTextProtocolList = this.sProtocols.split(",");
		var ctr;
		for (ctr = 0; ctr < aTextProtocolList.length; ++ctr)
		{
			aTextLinkProtocol = aTextProtocolList[ctr].split(":");
			if ((aTextLinkProtocol[0].length > 0) && (aTextLinkProtocol[1].length > 0))
			{
				aTextLinkProtocol[0] += ":";
				aTextLinkProtocol[0] += (aTextLinkProtocol[1].substr(aTextLinkProtocol[1].length - 1) != "!") ? "\\/\\/" : "";

				this.aProtocol.push(aTextLinkProtocol[0]);
				this.aRecognizeProtocolAs.push(aTextLinkProtocol[1]);
			}
		}

		this.aSubDomain = Array();
		this.aRecognizeSubDomainAs = Array();

		var aSubdomainProtocolList = this.sSubDomains.split(",");
		for (ctr = 0; ctr < aSubdomainProtocolList.length; ++ctr)
		{
			aTextLinkProtocol = aSubdomainProtocolList[ctr].split(":");
			if ((aTextLinkProtocol[0].length > 0) && (aTextLinkProtocol[1].length > 0))
			{
				this.aSubDomain.push(aTextLinkProtocol[0]);
				this.aRecognizeSubDomainAs.push(aTextLinkProtocol[1]);
			}
		}

		var sProtocol = "(" + this.aProtocol.join("|") + ")";
		var sSubDomain = "(" + this.aSubDomain.join("|") + ")";

		var sReservedChars = "@&=;:/?";
		var sUnreservedChars = "A-Za-z\\d!$%*()\\-_+',.";
		var sUnsafeChars = "#{}\\\\|\\^~\\[\\]`";
		var sAllowedChars = "[" + sUnreservedChars + sReservedChars + sUnsafeChars + "]";

		var sTopLevelDomains = "(?:(?:" + this.aTopLevelDomains.join(")|(?:") + "))";
		var sIPAddress = "(?:(?:(?:[0-1]?[0-9]?[0-9])|(?:2[0-4][0-9])|(?:25[0-5]))(?:\\.(?:(?:[0-1]?[0-9]?[0-9])|(?:2[0-4][0-9])|(?:25[0-5]))){3})";
		var sAllSubDomain = "[a-zA-Z0-9\\-]+";
		var sURLPath = sAllowedChars + "+[^@,!?.:;*<>(){}`'\"\\[\\]\\-\\s]";

		var sWWWAuth = "(?:(?:(?:[^*=:/<>(){}`'\"\\[\\]\\s]+:)?[^=:@/<>(){}`'\"\\[\\]\\s]+@)?" + sSubDomain + "\\.(?:" + sAllSubDomain + "\\.)+" + sTopLevelDomains + "(?:[/#?](?:" + sURLPath + ")?)?)";
		var sOtherOptionalAuth = "(?:(?:[^*=/<>(){}\\[\\]\\s]+@)?(" + sIPAddress + "|(?:(?:" + sAllSubDomain + "\\.)+" + sTopLevelDomains + "))[/]" + sURLPath + "(?:[#?](?:" + sURLPath + ")?)?)";
		var sOtherAuth = "(?:[^*=:/<>(){}`'\"\\[\\]\\s]+:[^=:/<>(){}`'\"\\[\\]\\s]+@(" + sIPAddress + "|(?:(?:" + sAllSubDomain + "\\.)+" + sTopLevelDomains + "))(?:[/](?:" + sURLPath + ")?)?(?:[#?](?:" + sURLPath + ")?)?)";

		var sRegExpHTTP = "(?:" + sProtocol + sURLPath + ")";
		var sRegExpWWW = "(?:" + sWWWAuth + "|" + sOtherOptionalAuth + "|" + sOtherAuth + ")";
		var sRegExpEmail = "([~#$%^&*`'`+?`._\\-\\w]+@" + "(?:(?:(?:" + sAllSubDomain + "\\.)+" + sTopLevelDomains + ")|(?:" + sIPAddress + "))(?:[~#$%^&*`'`+?*=`|._\\-\\w]+[^@,!?*=.:;<>(){}`'/\"\\[\\]\\-\\s])?)";
		this.sRegExpAll = RegExp(sRegExpHTTP + "|" + sRegExpWWW + "|" + sRegExpEmail, "i");

		sOtherOptionalAuth = "(?:(?:[^*=/<>(){}\\[\\]\\s]+@)?((" + sIPAddress + "|(?:(?:" + sAllSubDomain + "\\.)+" + sTopLevelDomains + ")))(?:/(?:" + sURLPath + ")?)?(?:[#?](?:" + sURLPath + ")?)?)";
		sRegExpWWW = "(?:" + sWWWAuth + "|" + sOtherOptionalAuth + ")";
		this.sRegExpSelected = RegExp("^(?:" + sRegExpHTTP + "|" + sRegExpEmail + "|" + sRegExpWWW + ")$", "i");

		this.sXPath = "//text()[not(ancestor::" + this.aExcludeElements.join(" or ancestor::") + ") and (";
		for (ctr = 0; ctr < this.aSubDomain.length; ++ctr)
		{
			this.sXPath += "contains(translate(., '" + this.aSubDomain[ctr].toUpperCase() + "', '" + this.aSubDomain[ctr].toLowerCase() + "'), '" + this.aSubDomain[ctr].toLowerCase() + "') or ";
		}
		this.sXPath += "contains(., '@') or contains(., '/') or contains(., ':'))]";

		return true;
	},

	WindowClick: function(e)
	{
		var ndClicked;

		if (e.button == 2)
		{
			ndClicked = e.target;

			var ndMenu = document.getElementById("linkification-contextmenu");
			if (!window._objLinkify.bContextMenu || (ndClicked.nodeName == "TEXTAREA") || (ndClicked.nodeName == "INPUT") || (ndClicked.nodeName == "A"))
			{
				ndMenu.setAttribute("collapsed", "true");
				return true;
			}

			ndMenu.setAttribute("collapsed", "false");
			return true;
		}

		if (window._objLinkify.nLinkified == 0)
		{
			return true;
		}

		ndClicked = window._objLinkify.GetParent(e.originalTarget, "a");
		if (!ndClicked.hasAttribute || !ndClicked.hasAttribute("class") || (ndClicked.getAttribute("class") != "linkification-ext"))
		{
			return true;
		}

		if (((e.button == 0) || (e.button == 1)) && !e.shiftKey && !e.altKey && !e.ctrlKey)
		{
			if (window._objLinkify.ClickLink(ndClicked.href, e.button))
			{
				e.preventDefault();
				e.stopPropagation();
				return false;
			}
		}

		return true;
	},

	WindowDoubleClick: function(e)
	{
		if (!window._objLinkify.bDoubleClick)
		{
			return false;
		}

		var ndDblClicked = e.originalTarget;
		if ((ndDblClicked.nodeName == "tab")
		|| (ndDblClicked.nodeName == "xul:spacer")
		|| (ndDblClicked.nodeName == "toolbar"))
		{
			return false;
		}

		var ndDocument = window._objLinkify.GetParent(ndDblClicked, "#document");

		var ndWindow = gBrowser.contentWindow;
		if (ndWindow.document != ndDocument)
		{
			if (ndWindow.frames.length > 0)
			{
				ndWindow = window._objLinkify.FindFrame(ndWindow, ndDocument);
			}
			else
			{
				return false;
			}
		}

		if ((ndWindow == false) || (typeof(ndWindow.getSelection) == "undefined"))
		{
			return false;
		}

		var objSelection = ndWindow.getSelection();
		if (!objSelection || objSelection.isCollapsed || !objSelection.anchorNode || (objSelection.anchorNode.nodeName != "#text"))
		{
			return false;
		}

		window._objLinkify.DoubleClickLink(objSelection);

		return true;
	},

	AutoLinkify: function(objEvent)
	{
		var ndDocument = objEvent.originalTarget;
		var aBodyTags = ndDocument.getElementsByTagName("body");
		var ndBody = (aBodyTags.length > 0) ? aBodyTags[0] : false;

		if (!window._objLinkify.bAutoLinkify || !ndBody || (ndBody.getAttribute("linkifying") == true))
		{
			return false;
		}
		ndBody.setAttribute("linkifying", true);

		var sHost = window._objLinkify.GetHost(ndDocument);
		var sLocation = window._objLinkify.GetSiteListed(sHost);

		if ((!sLocation && window._objLinkify.bUseWhitelist) || (sLocation && window._objLinkify.bUseBlacklist))
		{
			return false;
		}

		if (window._objLinkify.bEnableCharLimit)
		{
			var objRange = document.createRange();
			objRange.setEnd(ndBody, ndBody.childNodes.length);
			objRange.setStart(ndBody, 0);

			var nPageLength = objRange.toString().length;
			objRange.detach();
			if (nPageLength > window._objLinkify.nCharLimit)
			{
				return false;
			}
		}

		if (window._objLinkify.bThorough)
		{
			window._objLinkify.Linkify_Thorough(ndDocument);
		}
		else
		{
			window._objLinkify.Linkify_Simple(ndDocument);
		}
		return true;
	},

	WindowFocus: function()
	{
		window._objLinkify.SetLinkified();
	},

	PopupShowing: function(e)
	{
		var ndOpen = document.getElementById("linkification-contextmenu-open");
		window._objLinkify.sSelectedLink = window._objLinkify.GetSelectedText();

		if (window._objLinkify.bOpenSelected && (window._objLinkify.sSelectedLink.length > 0))
		{
			ndOpen.setAttribute("collapsed", "false");
		}
		else
		{
			ndOpen.setAttribute("collapsed", "true");
		}

		if (!window._objLinkify.bContextMenu)
		{
			return true;
		}

		var ndLinkify = document.getElementById("linkification-contextmenu-linkify");
		if (window._objLinkify.nLinkified > 0)
		{
			ndLinkify.setAttribute("label", window._objLinkify.objStringBundle.getString("linkification_popup_unlinkifypage"));
		}
		else
		{
			ndLinkify.setAttribute("label", window._objLinkify.objStringBundle.getString("linkification_popup_linkifypage"));
		}

		var sHost = window._objLinkify.GetHost();
		var sLocation = window._objLinkify.GetSiteListed(sHost);

		var ndList = document.getElementById("linkification-contextmenu-listoption");
		ndList.setAttribute("collapsed", "true");

		if ((!window._objLinkify.bUseWhitelist &&	!window._objLinkify.bUseBlacklist) || !sHost)
		{
			return true;
		}

		var sList;
		if (sLocation)
		{
			sList = window._objLinkify.bUseWhitelist ? window._objLinkify.objStringBundle.getString("linkification_status_whitelist_remove") : window._objLinkify.objStringBundle.getString("linkification_status_blacklist_remove");
			sList = sList.replace("xxxxxxx", "'" + sLocation + "'");
		}
		else
		{
			sList = window._objLinkify.bUseWhitelist ? window._objLinkify.objStringBundle.getString("linkification_status_whitelist_add") : window._objLinkify.objStringBundle.getString("linkification_status_blacklist_add");
			sList = sList.replace("xxxxxxx", "'" + sHost + "'");
		}

		ndList.setAttribute("label", sList);
		ndList.setAttribute("collapsed", "false");

		return true;
	},

	InitStatusMenu: function()
	{
		var ndLinkify = document.getElementById("linkification-status-linkify");
		if (window._objLinkify.nLinkified > 0)
		{
			ndLinkify.setAttribute("label", window._objLinkify.objStringBundle.getString("linkification_popup_unlinkifypage"));
		}
		else
		{
			ndLinkify.setAttribute("label", window._objLinkify.objStringBundle.getString("linkification_popup_linkifypage"));
		}

		var sHost = window._objLinkify.GetHost();
		var sLocation = window._objLinkify.GetSiteListed(sHost);

		var ndList = document.getElementById("linkification-status-listoption");
		ndList.setAttribute("collapsed", "true");

		if ((!window._objLinkify.bUseWhitelist &&	!window._objLinkify.bUseBlacklist) || !sHost)
		{
			return true;
		}

		var sList;
		if (sLocation)
		{
			sList = window._objLinkify.bUseWhitelist ? window._objLinkify.objStringBundle.getString("linkification_status_whitelist_remove") : window._objLinkify.objStringBundle.getString("linkification_status_blacklist_remove");
			sList = sList.replace("xxxxxxx", "'" + sLocation + "'");
		}
		else
		{
			sList = window._objLinkify.bUseWhitelist ? window._objLinkify.objStringBundle.getString("linkification_status_whitelist_add") : window._objLinkify.objStringBundle.getString("linkification_status_blacklist_add");
			sList = sList.replace("xxxxxxx", "'" + sHost + "'");
		}

		ndList.setAttribute("label", sList);
		ndList.setAttribute("collapsed", "false");

		return true;
	},

	UserLinkify: function()
	{
		if (this.bFromPopup)
		{
			return false;
		}

		this.bFromPopup = true;

		var ndDocument, ndBody, aBodyTags;

		this.GetWindows(gBrowser.contentWindow);
		for (var ctr = 0; ctr < this.aFrameWindows.length; ++ctr)
		{
			ndDocument = this.aFrameWindows[ctr].document;
			aBodyTags = ndDocument.getElementsByTagName("body");
			ndBody = (aBodyTags.length > 0) ? aBodyTags[0] : false;

			if (!ndBody || (ndBody.getAttribute("linkifying") == true))
			{
				continue;
			}
			ndBody.setAttribute("linkifying", true);

			if (this.nLinkified > 0)
			{
				this.Undo(ndDocument);
			}
			else
			{
				if (this.bThorough)
				{
					this.Linkify_Thorough(ndDocument);
				}
				else
				{
					this.Linkify_Simple(ndDocument);
				}
			}
		}

		this.bFromPopup = false;

		return true;
	},

	Linkify_Thorough: function(ndRoot)
	{
		var ndDocument = this.GetParent(ndRoot, "#document");
		var ndBody = ndDocument.getElementsByTagName("body")[0];

		var ndNode = ndRoot;
		while (ndNode.nodeName != "#document")
		{
			if (this.IsExcluded(ndDocument, ndNode))
			{
				return true;
			}
			ndNode = ndNode.parentNode;
		}
		ndNode = null;

		var objStartTime = new Date();

		ndBody.setAttribute("linkifycurrent", 0);
		ndBody.setAttribute("linkifymax", 0);
		ndBody.setAttribute("linkifytraversed", "false");

		this.TraverseNodes(ndDocument, ndBody, ndRoot, ndRoot, false, [], "", objStartTime);

		return true;
	},

	TraverseNodes: function(ndDocument, ndBody, ndRoot, ndNode, bChildrenDone, aTraverseNodes, sTraverseText, objStartTime)
	{
		var ndContinue;

		for (var nIterations = 0; (ndNode && (nIterations < 75)); ++nIterations)
		{
			if (ndNode.nodeName == "#text")
			{
				if (!bChildrenDone)
				{
					aTraverseNodes.push(ndNode);
					sTraverseText += ndNode.nodeValue;
				}
			}
			else if (aTraverseNodes.length && ndNode.nodeName && !window._objLinkify.aInlineHash[ndNode.nodeName.toLowerCase()])
			{
				ndBody.setAttribute("linkifymax", (parseInt(ndBody.getAttribute("linkifymax"), 10) + 1));
				window._objLinkify.CreateLinks_Thorough(ndDocument, ndBody, aTraverseNodes, sTraverseText, objStartTime);
				aTraverseNodes = [];
				sTraverseText = "";
			}

			if (bChildrenDone && (ndNode == ndRoot))
			{
				break;
			}
			else if (!bChildrenDone && ndNode.firstChild && !window._objLinkify.IsExcluded(ndDocument, ndNode))
			{
				ndNode = ndNode.firstChild;
			}
			else
			{
				if (ndNode.nextSibling)
				{
					ndNode = ndNode.nextSibling;
					bChildrenDone = false;
				}
				else
				{
					ndNode = ndNode.parentNode;
					bChildrenDone = true;
				}
			}
		}

		if (ndNode && (ndNode != ndRoot))
		{
			setTimeout(window._objLinkify.TraverseNodes, 20, ndDocument, ndBody, ndRoot, ndNode, bChildrenDone, aTraverseNodes, sTraverseText, objStartTime);
			return true;
		}

		window._objLinkify.Linkify_Thorough_End(ndDocument, objStartTime, true);
		return true;
	},

	CreateLinks_Thorough: function(ndDocument, ndBody, aTraverseNodes, sTraverseText, objStartTime)
	{
		var aMatch, sStyle, sHREF, nIndex, nTextLength, objRange, ndStart, ndEnd, nRangeStart, nRangeEnd, nSearch, ndAnchor;
		var ndReturn = null;
		var nIterations = 0;

		while ((aMatch = window._objLinkify.sRegExpAll.exec(sTraverseText)) && (nIterations++ < 20))
		{
			sHREF = window._objLinkify.GetLinkHREF(aMatch);

			nTextLength = 0;
			nIndex = 0;
			nSearch = aMatch.index;
			while (nSearch > (nTextLength + aTraverseNodes[nIndex].nodeValue.length))
			{
				nTextLength += aTraverseNodes[nIndex++].nodeValue.length;
			}
			ndStart = aTraverseNodes[nIndex];
			nRangeStart = nSearch - nTextLength;

			nSearch = aMatch.index + aMatch[0].length;
			while (nSearch > (nTextLength + aTraverseNodes[nIndex].nodeValue.length))
			{
				nTextLength += aTraverseNodes[nIndex++].nodeValue.length;
			}
			ndEnd = aTraverseNodes[nIndex];
			nRangeEnd = nSearch - nTextLength;

			if (window._objLinkify.IsImage(sHREF) && (!window._objLinkify.bLinkifyImageURLs)
			|| (aMatch[1] && !window._objLinkify.bLinkifyProtocol)
			|| (aMatch[2] && !window._objLinkify.bLinkifyKnown)
			|| ((aMatch[3] || aMatch[4]) && !window._objLinkify.bLinkifyUnknown)
			|| (aMatch[5] && !window._objLinkify.bLinkifyEmail))
			{
				aTraverseNodes[nIndex].splitText(nSearch - nTextLength);
				aTraverseNodes[nIndex] = aTraverseNodes[nIndex].nextSibling;

				ndReturn = aTraverseNodes[nIndex];

				aTraverseNodes.splice(0, nIndex);
				sTraverseText = sTraverseText.substr(nSearch);

				continue;
			}

			objRange = document.createRange();
			objRange.setStart(ndStart, nRangeStart);
			objRange.setEnd(ndEnd, nRangeEnd);

			ndAnchor = ndDocument.createElement("a");
			ndAnchor.setAttribute("title", "Linkification: " + sHREF);
			ndAnchor.setAttribute("href", sHREF);
			ndAnchor.setAttribute("class", "linkification-ext");
			sStyle = (window._objLinkify.bTextColor) ? "color:" + window._objLinkify.sTextColor : "";
			if (window._objLinkify.bBackgroundColor)
			{
				sStyle += (sStyle.length > 0) ? "; " : "";
				sStyle += "background-color:" + window._objLinkify.sBackgroundColor;
			}

			if (sStyle.length > 0)
			{
				ndAnchor.setAttribute("style", sStyle);
			}

			ndAnchor.appendChild(objRange.extractContents());
			objRange.insertNode(ndAnchor);

			objRange.detach();

			ndReturn = ndAnchor.nextSibling;
			if ((ndAnchor.nextSibling) && (ndAnchor.nextSibling.nodeName == "#text"))
			{
				aTraverseNodes.splice(0, nIndex + 1, ndAnchor.nextSibling);
			}
			else
			{
				aTraverseNodes.splice(0, nIndex + 1);
			}
			sTraverseText = sTraverseText.substr(nSearch);
		}

		if (aMatch)
		{
			setTimeout(window._objLinkify.CreateLinks_Thorough, 10, ndDocument, ndBody, aTraverseNodes, sTraverseText, objStartTime);
			return true;
		}

		ndBody.setAttribute("linkifycurrent", (parseInt(ndBody.getAttribute("linkifycurrent"), 10) + 1));
		window._objLinkify.Linkify_Thorough_End(ndDocument, objStartTime, false);
		return true;
	},

	Linkify_Thorough_End: function(ndDocument, objStartTime, bTraversed)
	{
		var ndBody = ndDocument.getElementsByTagName("body")[0];

		if (bTraversed)
		{
			ndBody.setAttribute("linkifytraversed", "true");
		}

		if ((ndBody.getAttribute("linkifytraversed") == "false") || (parseInt(ndBody.getAttribute("linkifycurrent"), 10) != parseInt(ndBody.getAttribute("linkifymax"), 10)))
		{
			return false;
		}

		var objStopTime = new Date();

		var aAttributes = Array();
		aAttributes["class"] = "linkification-ext";

		ndBody.setAttribute("linkified", this.GetElementsByAttributes(ndDocument, aAttributes).length);
		ndBody.setAttribute("linkifytime", (objStopTime.getTime() - objStartTime.getTime()));
		ndBody.setAttribute("linkifying", false);
		ndBody.removeAttribute("linkifytraversed");
		ndBody.removeAttribute("linkifycurrent");
		ndBody.removeAttribute("linkifymax");

		this.SetLinkified();

		delete objStartTime;
		delete objStopTime;
		return true;
	},

	Linkify_Simple: function(ndDocument)
	{
		var ndBody = ndDocument.getElementsByTagName("body")[0];
		var objStartTime = new Date();

		var objResult = this.XPathQuery(this.sXPath, ndDocument);

		ndBody.setAttribute("linkifycurrent", 0);
		ndBody.setAttribute("linkifymax", objResult.snapshotLength);
		for (var ctr = 0; ctr < objResult.snapshotLength; ++ctr)
		{
			this.CreateLinks_Simple(ndDocument, objResult.snapshotItem(ctr), ctr, objStartTime);
		}

		return true;
	},

	CreateLinks_Simple: function(ndDocument, ndText, nProgressIndex, objStartTime)
	{
		var sHREF;
		var sSource = ndText.nodeValue;
		var ndParent = ndText.parentNode;
		var ndNextSibling = ndText.nextSibling;

		for (var aMatch = null, bMatched = false, nIterations = 0, nNodeLinks = 0; (nIterations < 3) && (aMatch = window._objLinkify.sRegExpAll.exec(sSource)); ++nIterations)
		{
			if (!bMatched)
			{
				bMatched = true;
				ndParent.removeChild(ndText);
			}

			ndParent.insertBefore(ndDocument.createTextNode(sSource.substring(0, aMatch.index)), ndNextSibling);
			sHREF = window._objLinkify.GetLinkHREF(aMatch);

			if (window._objLinkify.IsImage(sHREF) && (!window._objLinkify.bLinkifyImageURLs)
			|| (aMatch[1] && !window._objLinkify.bLinkifyProtocol)
			|| (aMatch[2] && !window._objLinkify.bLinkifyKnown)
			|| ((aMatch[3] || aMatch[4]) && !window._objLinkify.bLinkifyUnknown)
			|| (aMatch[5] && !window._objLinkify.bLinkifyEmail))
			{
				ndParent.insertBefore(ndDocument.createTextNode(aMatch[0]), ndNextSibling);
				sSource = sSource.substr(aMatch.index + aMatch[0].length);
				continue;
			}

			var ndAnchor = ndDocument.createElement("a");
			ndAnchor.setAttribute("title", "Linkification: " + sHREF);
			ndAnchor.setAttribute("href", sHREF);
			ndAnchor.setAttribute("class", "linkification-ext");

			var sStyle = (window._objLinkify.bTextColor) ? "color:" + window._objLinkify.sTextColor : "";
			if (window._objLinkify.bBackgroundColor)
			{
				sStyle += (sStyle.length > 0) ? "; " : "";
				sStyle += "background-color:" + window._objLinkify.sBackgroundColor;
			}

			if (sStyle.length > 0)
			{
				ndAnchor.setAttribute("style", sStyle);
			}

			ndAnchor.appendChild(ndDocument.createTextNode(aMatch[0]));
			ndParent.insertBefore(ndAnchor, ndNextSibling);

			sSource = sSource.substr(aMatch.index + aMatch[0].length);
			++nNodeLinks;
		}

		if (bMatched)
		{
			var ndAfter = ndDocument.createTextNode(sSource);
			ndParent.insertBefore(ndAfter, ndNextSibling);
		}

		if (nIterations == 3)
		{
			setTimeout(window._objLinkify.CreateLinks_Simple, 20, ndDocument, ndAfter, nProgressIndex, objStartTime);
			return true;
		}

		var ndBody = ndDocument.getElementsByTagName("body")[0];
		var nLinkified = parseInt(ndBody.getAttribute("linkifycurrent"), 10);
		ndBody.setAttribute("linkifycurrent", (nLinkified + 1));

		if ((nLinkified + 1) < parseInt(ndBody.getAttribute("linkifymax"), 10))
		{
			return true;
		}

		window._objLinkify.Linkify_Simple_End(ndDocument, objStartTime);
		return true;
	},

	Linkify_Simple_End: function(ndDocument, objStartTime)
	{
		var ndBody = ndDocument.getElementsByTagName("body")[0];

		var objStopTime = new Date();

		var aAttributes = Array();
		aAttributes["class"] = "linkification-ext";

		ndBody.setAttribute("linkified", this.GetElementsByAttributes(ndDocument, aAttributes).length);
		ndBody.setAttribute("linkifytime", objStopTime.getTime() - objStartTime.getTime());
		ndBody.setAttribute("linkifying", false);
		ndBody.removeAttribute("linkifycurrent");
		ndBody.removeAttribute("linkifymax");

		this.SetLinkified();

		delete objStartTime;
		delete objStopTime;
		return true;
	},

	SplitNodes: function(ndText, nTextLength)
	{
		var sRegExpSpace = /\s/;
		var sSource, aMatch;

		while (ndText.nodeValue.length > nTextLength)
		{
			sSource = ndText.nodeValue.substr(nTextLength);
			aMatch = sRegExpSpace.exec(sSource);
			if (!aMatch)
			{
				return true;
			}

			ndText.splitText(nTextLength + aMatch.index);
			ndText = ndText.nextSibling;
		}

		return true;
	},

	GetSelectedText: function()
	{
		var ndWindow, objSelection;

		this.GetWindows(gBrowser.contentWindow);
		for (var ctr = 0; ctr < this.aFrameWindows.length; ++ctr)
		{
			objSelection = this.aFrameWindows[ctr].getSelection();
			if (!objSelection || objSelection.isCollapsed || !objSelection.anchorNode || (objSelection.anchorNode.nodeName != "#text"))
			{
				objSelection = false;
			}
			else
			{
				break;
			}
		}

		if (!objSelection)
		{
			return "";
		}

		var sSelectedText = objSelection.toString().replace(/\s/g, "");
		if (sSelectedText.length == 0)
		{
			return "";
		}

		var aMatch = this.sRegExpSelected.exec(sSelectedText);
		return (aMatch) ? this.GetSelectedLinkHREF(aMatch) : "";
	},

	GetSelectedLinkHREF: function(aMatch)
	{
		var sHREF = "";

		if (aMatch[1])
		{
			sHREF = aMatch[0].replace(aMatch[1], this.GetProtocol(aMatch[1]));
		}
		else if (aMatch[2])
		{
			sHREF = "mailto:" + aMatch[0];
		}
		else if (aMatch[3])
		{
			sHREF = this.GetDomainProtocol(aMatch[3]) + aMatch[0];
		}
		else if (aMatch[4])
		{
			sHREF = this.GetDomainProtocol(aMatch[4]) + aMatch[0];
		}
		else if (aMatch[5])
		{
			sHREF = this.GetDomainProtocol(aMatch[5]) + aMatch[0];
		}

		return sHREF;
	},

	GetLinkHREF: function(aMatch)
	{
		var sHREF = "";
		if (aMatch[1])
		{
			sHREF = aMatch[0].replace(aMatch[1], this.GetProtocol(aMatch[1]));
		}
		else if (aMatch[2])
		{
			sHREF = this.GetDomainProtocol(aMatch[2]) + aMatch[0];
		}
		else if (aMatch[3])
		{
			sHREF = this.GetDomainProtocol(aMatch[3]) + aMatch[0];
		}
		else if (aMatch[4])
		{
			sHREF = this.GetDomainProtocol(aMatch[4]) + aMatch[0];
		}
		else if (aMatch[5])
		{
			sHREF = "mailto:" + aMatch[0];
		}

		return sHREF;
	},

	Undo: function(ndDocument)
	{
		var ndBody = ndDocument.getElementsByTagName("body")[0];
		if (ndBody.getAttribute("linkifying") == true)
		{
			return true;
		}
		ndBody.setAttribute("linkifying", true);

		var ndParent;

		var aAttributes = Array();
		aAttributes["class"] = "linkification-ext";
		var aAnchors = this.GetElementsByAttributes(ndDocument, aAttributes);

		for (var ctr = aAnchors.length - 1; ctr >= 0; --ctr)
		{
			ndParent = aAnchors[ctr].parentNode;
			while (aAnchors[ctr].firstChild)
			{
				ndParent.insertBefore(aAnchors[ctr].removeChild(aAnchors[ctr].firstChild), aAnchors[ctr]);
			}
			ndParent.removeChild(aAnchors[ctr]);
		}

		ndBody.removeAttribute("linkified");
		ndBody.removeAttribute("linkifytime");
		ndBody.setAttribute("linkifying", false);

		this.SetLinkified();

		return true;
	},

	GetProtocol: function(sProtocolMatch)
	{
		var reTest;
		for (var ctr = 0; ctr < this.aProtocol.length; ++ctr)
		{
			reTest = RegExp("^" + this.aProtocol[ctr] + "$", "i");
			if (reTest.test(sProtocolMatch))
			{
				return (this.aRecognizeProtocolAs[ctr].substr(this.aRecognizeProtocolAs[ctr].length - 1) == "!") ? this.aRecognizeProtocolAs[ctr].substr(0, this.aRecognizeProtocolAs[ctr].length - 1) + ":" : this.aRecognizeProtocolAs[ctr] + "://";
			}
		}

		return true;
	},

	GetDomainProtocol: function(sSubdomain)
	{
		var reTest;
		for (var ctr = 0; ctr < this.aSubDomain.length; ++ctr)
		{
			reTest = RegExp("^" + this.aSubDomain[ctr] + "$", "i");
			if (reTest.test(sSubdomain))
			{
				return this.aRecognizeSubDomainAs[ctr] + "://";
			}
		}

		return "http://";
	},

	IsImage: function(sFile)
	{
		sFile = (sFile.indexOf("?") > -1) ? sFile.substr(0, sFile.indexOf("?")) : sFile;
		sFile = (sFile.indexOf("#") > -1) ? sFile.substr(0, sFile.indexOf("#")) : sFile;
		sFile = (sFile.lastIndexOf(".") > -1) ? sFile.substr(sFile.lastIndexOf(".")) : sFile;

		return ((sFile == ".jpeg") || (sFile == ".jpg") || (sFile == ".gif") || (sFile == ".png") || (sFile == ".bmp"));
	},

	SetLinkified: function()
	{
		this.nLinkified = 0;
		this.nLinkifyTime = 0;

		var ndDocument, ndBody, aBodyTags;

		this.GetWindows(gBrowser.contentWindow);
		for (var ctr = 0; ctr < this.aFrameWindows.length; ++ctr)
		{
			ndDocument = this.aFrameWindows[ctr].document;
			aBodyTags = ndDocument.getElementsByTagName("body");
			ndBody = (aBodyTags.length > 0) ? aBodyTags[0] : false;

			if (ndBody === false)
			{
				continue;
			}

			if (ndBody.hasAttribute && ndBody.hasAttribute("linkified") && ndBody.getAttribute("linkified"))
			{
				this.nLinkified += parseInt(ndBody.getAttribute("linkified"), 10);
				this.nLinkifyTime += parseInt(ndBody.getAttribute("linkifytime"), 10);
			}
		}

		var ndStatus = document.getElementById("linkification-status-hbox");
		if (this.nLinkified > 0)
		{
			ndStatus.setAttribute("tooltiptext", this.objStringBundle.getString("linkification_statusbartooltip") + " " + this.nLinkified + " (" + parseInt(this.nLinkifyTime, 10) + "ms)");
		}
		else
		{
			ndStatus.setAttribute("tooltiptext", this.objStringBundle.getString("linkification_statusbartooltip") + " " + this.nLinkified);
		}
		ndStatus.src = (this.nLinkified > 0) ? 'chrome://linkification/skin/link-on.png' : 'chrome://linkification/skin/link-off.png';

		return true;
	},

	ToggleLinkify: function()
	{
		this.prefService.setBoolPref('Linkify_Toggle', !this.bAutoLinkify);
		this.bAutoLinkify = !this.bAutoLinkify;

		return true;
	},

	ClickLink: function(sHREF, nButton)
	{
		var bOpenWindow = this.bLinksOpenWindows;
		var bOpenTab = (this.bLinksOpenTabs || (nButton == 1));

		if (sHREF.indexOf(":") > -1)
		{
			var sProtocol = sHREF.substr(0, sHREF.indexOf(":")).toLowerCase();
			if ((sProtocol != "http") && (sProtocol != "https") && (sProtocol != "ftp") && (sProtocol != "about"))
			{
				bOpenWindow = false;
				bOpenTab = false;
			}
		}

		if (bOpenWindow)
		{
			var objPost = {};
			window.delayedOpenWindow(getBrowserURL(), "all,dialog=no", sHREF, objPost);
		}
		else if (bOpenTab)
		{
			var objTab = gBrowser.addTab(sHREF, null, null);
			if (this.bLinksOpenTabs && !this.bTabsOpenInBG)
			{
				gBrowser.selectedTab = objTab;
			}
		}
		else
		{
			gBrowser.loadURI(sHREF, null, null);
		}

		return true;
	},

	OpenSelected: function()
	{
		return this.ClickLink(this.sSelectedLink, 0);
	},

	ListSite: function()
	{
		var sHost = this.GetHost();
		if (!sHost)
		{
			return false;
		}

		var sLocation = this.GetSiteListed(sHost);
		var aSiteList = this.sSitelist.split(",");

		if (sLocation)
		{
			var aNewList = Array();
			for (var ctr = 0; ctr < aSiteList.length; ++ctr)
			{
				if (aSiteList[ctr] != sLocation)
				{
					aNewList.push(aSiteList[ctr]);
				}
			}
			this.sSitelist = aNewList.join(",");
		}
		else
		{
			if (aSiteList[0].length > 0)
			{
				aSiteList.push(sHost);
			}
			else
			{
				aSiteList[0] = sHost;
			}
			this.sSitelist = aSiteList.join(",");
		}

		this.prefService.setCharPref('Linkify_SiteList', this.sSitelist);

		return true;
	},

	GetWindows: function(ndWindow)
	{
		if (ndWindow == ndWindow.top)
		{
			this.aFrameWindows = Array();
			this.aFrameWindows.push(ndWindow);
		}

		for (var ctr = 0; ctr < ndWindow.frames.length; ++ctr)
		{
			this.aFrameWindows.push(ndWindow.frames[ctr]);

			if (ndWindow.frames[ctr].frames.length > 0)
			{
				this.GetWindows(ndWindow.frames[ctr]);
			}
		}

		return true;
	},

	FindFrame: function(ndWindow, ndDocument)
	{
		this.GetWindows(ndWindow);
		for (var ctr = 0; ctr < this.aFrameWindows.length; ++ctr)
		{
			if (this.aFrameWindows[ctr].document == ndDocument)
			{
				return this.aFrameWindows[ctr];
			}
		}

		return false;
	},

	DoubleClickLink: function(objSelection)
	{
		var sPreText = this.WholeTextBefore(objSelection.anchorNode);
		var sPostText = this.WholeTextAfter(objSelection.anchorNode);

		var nLeftBound = sPreText.length + objSelection.anchorOffset;
		var nRightBound = nLeftBound + objSelection.toString().length;

		var sCompleteText = sPreText + objSelection.anchorNode.nodeValue + sPostText;

		for (var aMatch = null; ((aMatch = this.sRegExpAll.exec(sCompleteText)) && (nRightBound > aMatch.index));)
		{
			if (nLeftBound <= (aMatch.index + aMatch[0].length))
			{
				sHREF = this.GetLinkHREF(aMatch);
				return this.ClickLink(sHREF, 0);
			}

			nLeftBound -= (aMatch.index + aMatch[0].length);
			nRightBound -= (aMatch.index + aMatch[0].length);
			sCompleteText = sCompleteText.substr((aMatch.index + aMatch[0].length));
		}

		return true;
	},

	WholeTextBefore: function(ndNode)
	{
		if (ndNode.nodeName != "#text")
		{
			return false;
		}

		var ndDocument = this.GetParent(ndNode, "#document");
		var sQuery, objResult;

		var nOffset = 0;
		var ndTraverseNode = ndNode;
		var ndBlockLevelNode = false;
		while (!ndBlockLevelNode)
		{
			if (!ndTraverseNode.previousSibling)
			{
				ndTraverseNode = ndTraverseNode.parentNode;
				if (!this.aInlineHash[ndTraverseNode.nodeName.toLowerCase()])
				{
					ndBlockLevelNode = ndTraverseNode;
					nOffset = 0;
				}
			}
			else
			{
				ndTraverseNode = ndTraverseNode.previousSibling;

				try
				{
					ndTraverseNode.setAttribute("linkification-marker", "");
					sQuery = "//node()[ancestor-or-self::*[@linkification-marker] and not(self::text() or self::comment() or self::" + this.aInlineElements.join(" or self::") + ")]";
					objResult = this.XPathQuery(sQuery, ndDocument);
					ndTraverseNode.removeAttribute("linkification-marker");

					if (objResult.snapshotLength > 0)
					{
						ndBlockLevelNode = objResult.snapshotItem(objResult.snapshotLength - 1);
						nOffset = ndBlockLevelNode.childNodes.length;
					}
				}
				catch (sError)
				{
				}
			}
		}

		var objRange = document.createRange();
		objRange.setEnd(ndNode, 0);
		objRange.setStart(ndBlockLevelNode, nOffset);

		var sText = objRange.toString();
		objRange.detach();
		return sText;
	},

	WholeTextAfter: function(ndNode)
	{
		if (ndNode.nodeName != "#text")
		{
			return false;
		}

		var ndDocument = this.GetParent(ndNode, "#document");
		var sQuery, objResult;

		var nOffset = 0;
		var ndTraverseNode = ndNode;
		var ndBlockLevelNode = false;
		while (!ndBlockLevelNode)
		{
			if (!ndTraverseNode.nextSibling)
			{
				ndTraverseNode = ndTraverseNode.parentNode;
				if (!this.aInlineHash[ndTraverseNode.nodeName.toLowerCase()])
				{
					ndBlockLevelNode = ndTraverseNode;
					nOffset = ndBlockLevelNode.childNodes.length;
				}
			}
			else
			{
				ndTraverseNode = ndTraverseNode.nextSibling;

				try
				{
					ndTraverseNode.setAttribute("linkification-marker", "");
					sQuery = "//node()[ancestor-or-self::*[@linkification-marker] and not(self::text() or self::comment() or self::" + this.aInlineElements.join(" or self::") + ")]";
					objResult = this.XPathQuery(sQuery, ndDocument);
					ndTraverseNode.removeAttribute("linkification-marker");

					if (objResult.snapshotLength > 0)
					{
						ndBlockLevelNode = objResult.snapshotItem(0);
						nOffset = 0;
					}
				}
				catch (sError)
				{
				}
			}
		}

		var objRange = document.createRange();
		objRange.setEnd(ndBlockLevelNode, nOffset);
		objRange.setStart(ndNode, ndNode.length);

		var sText = objRange.toString();
		objRange.detach();
		return sText;
	},

	WholeText: function(ndNode)
	{
		return (ndNode.nodeName == "#text") ? (this.WholeTextBefore(ndNode) + ndNode.nodeValue + this.WholeTextAfter(ndNode)) : false;
	},

	GetElementsByAttributes: function(ndDocument, aAttributes)
	{
		var sAttributeName;

		var sQuery = "";
		for (sAttributeName in aAttributes)
		{
			sQuery += "(//node()[@" + sAttributeName;
			sQuery += (aAttributes[sAttributeName].length > 0) ? "='" + aAttributes[sAttributeName] + "'" : "";
			sQuery += "]) or ";
		}
		sQuery = sQuery.substring(0, sQuery.length - 4);
		var objResult = this.XPathQuery(sQuery, ndDocument);

		var aNodes = Array();
		for (var ctr = 0; ctr < objResult.snapshotLength; ++ctr)
		{
			aNodes.push(objResult.snapshotItem(ctr));
		}

		return aNodes;
	},

	XPathQuery: function(sQuery, ndDocument)
	{
		var ndOwnerDocument = (ndDocument.ownerDocument == null) ? ndDocument.documentElement : ndDocument.ownerDocument.documentElement;

		var objXPE = new XPathEvaluator();
		var objNSResolver = objXPE.createNSResolver(ndOwnerDocument);
		var objResult = objXPE.evaluate(sQuery, ndDocument, objNSResolver, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
		delete objXPE;

		return objResult;
	},

	GetHost: function(ndDocument)
	{
		var sHost;
		if (!ndDocument)
		{
			var objURI = gBrowser.webNavigation.currentURI;
			try
			{
				sHost = objURI.host;
			}
			catch(sError)
			{
				return false;
			}
		}
		else
		{
			sHost = ndDocument.location.href;
			var nProtocol = sHost.indexOf("://");
			if (nProtocol == -1)
			{
				return false;
			}

			sHost = sHost.substr(nProtocol + 3);

			var nSlash = sHost.indexOf("/");
			sHost = (nSlash == -1) ? sHost : sHost.substr(0, nSlash);
		}

		return sHost;
	},

	GetSiteListed: function(sHost)
	{
		var aSiteList = this.sSitelist.split(",");

		if (!sHost)
		{
			return false;
		}

		for (var ctr = 0; ctr < aSiteList.length; ++ctr)
		{
			if (sHost.lastIndexOf(aSiteList[ctr]) > -1)
			{
				return aSiteList[ctr];
			}
		}

		return false;
	},

	StatusBarClicked: function(e)
	{
		if (e.button != 0)
		{
			return true;
		}

		this.UserLinkify();

		return true;
	},

	IsExcluded: function(ndDocument, ndNode)
	{
		if (ndNode.nodeName == "#text")
		{
			ndNode = ndNode.parentNode;
		}

		if (ndNode.setAttribute)
		{
			ndNode.setAttribute("linkification-marker", "");
			var sQuery = "//node()[self::*[@linkification-marker] and (self::" + this.aExcludeElements.join(" or self::") + ")]";
			var objResult = this.XPathQuery(sQuery, ndDocument);
			ndNode.removeAttribute("linkification-marker");

			return (objResult.snapshotLength > 0);
		}

		return false;
	},

	GetParent: function(ndNode, sNodeName)
	{
		sNodeName = sNodeName.toLowerCase();
		while (ndNode.nodeName.toLowerCase() != "#document")
		{
			if (ndNode.nodeName.toLowerCase() == sNodeName)
			{
				return ndNode;
			}

			ndNode = ndNode.parentNode;
		}

		return (sNodeName == "#document") ? ndNode : false;
	},

	ObjectDebug: function(objItem)
	{
		var sAlert = "";
		for (var nIndex in objItem)
		{
			sAlert += nIndex + ": " + objItem[nIndex] + "\n";
		}

		alert(sAlert);
		return true;
	},

	Options: function()
	{
		window.openDialog("chrome://linkification/content/linkificationOptions.xul", "linkificationOptions", "centerscreen,chrome,modal");

		return true;
	}
};

function Linkify_Init()
{
	window.removeEventListener('load', Linkify_Init, false);

	window._objLinkify = objLinkify;
	window._objLinkify.InitServices();

	return true;
}

window.addEventListener('load', Linkify_Init, false);